package cn.com.qmth.examcloud.core.examwork.dao;

import java.util.List;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.QueryByExampleExecutor;

import cn.com.qmth.examcloud.core.examwork.dao.entity.ExamStudentEntity;

public interface ExamStudentRepo
		extends
			JpaRepository<ExamStudentEntity, Long>,
			QueryByExampleExecutor<ExamStudentEntity>,
			JpaSpecificationExecutor<ExamStudentEntity> {

	List<ExamStudentEntity> findByStudentId(Long examId);

	List<ExamStudentEntity> findByIdIn(List<Long> ids);

	@Modifying
	@Query("delete from ExamStudentEntity s where s.examId = ?1")
	void deleteByExamId(Long examId);

	ExamStudentEntity findByExamIdAndStudentIdAndCourseId(Long examId, Long studentId,
			Long courseId);
}
